<!doctype html>
<html>
<head>
    <title>Tor 0.2.1.13-alpha released | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.2.1.13-alpha released | Tor Project">
    <meta property="og:description" content="Tor 0.2.1.13-alpha includes another big pile of minor bugfixes and cleanups. We&#39;re finally...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-02113-alpha-released/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.2.1.13-alpha released
      </h1>
    <p class="meta">by phobos | March 13, 2009</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Tor 0.2.1.13-alpha includes another big pile of minor bugfixes and<br />
cleanups. We're finally getting close to a release candidate.</p>

<p><a href="https://www.torproject.org/download" rel="nofollow">https://www.torproject.org/download</a></p>

<p>Changes in version 0.2.1.13-alpha - 2009-03-09<br />
<strong>Major bugfixes:</strong></p>

<ul>
<li>Correctly update the list of which countries we exclude as<br />
      exits, when the GeoIP file is loaded or reloaded. Diagnosed by<br />
      lark. Bugfix on 0.2.1.6-alpha.</li>
</ul>

<p><strong>Minor bugfixes (on 0.2.0.x and earlier):</strong></p>

<ul>
<li>Automatically detect MacOSX versions earlier than 10.4.0, and<br />
      disable kqueue from inside Tor when running with these versions.<br />
      We previously did this from the startup script, but that was no<br />
      help to people who didn't use the startup script. Resolves bug 863.</li>
<li>When we had picked an exit node for a connection, but marked it as<br />
      "optional", and it turned out we had no onion key for the exit,<br />
      stop wanting that exit and try again. This situation may not<br />
      be possible now, but will probably become feasible with proposal<br />
      158. Spotted by rovv. Fixes another case of bug 752.</li>
<li>Clients no longer cache certificates for authorities they do not<br />
      recognize. Bugfix on 0.2.0.9-alpha.</li>
<li>When we can't transmit a DNS request due to a network error, retry<br />
      it after a while, and eventually transmit a failing response to<br />
      the RESOLVED cell. Bugfix on 0.1.2.5-alpha.</li>
<li>If the controller claimed responsibility for a stream, but that<br />
      stream never finished making its connection, it would live<br />
      forever in circuit_wait state. Now we close it after SocksTimeout<br />
      seconds. Bugfix on 0.1.2.7-alpha; reported by Mike Perry.</li>
<li>Drop begin cells to a hidden service if they come from the middle<br />
      of a circuit. Patch from lark.</li>
<li>When we erroneously receive two EXTEND cells for the same circuit<br />
      ID on the same connection, drop the second. Patch from lark.</li>
<li>Fix a crash that occurs on exit nodes when a nameserver request<br />
      timed out. Bugfix on 0.1.2.1-alpha; our CLEAR debugging code had<br />
      been suppressing the bug since 0.1.2.10-alpha. Partial fix for<br />
      bug 929.</li>
<li>Do not assume that a stack-allocated character array will be<br />
      64-bit aligned on platforms that demand that uint64_t access is<br />
      aligned. Possible fix for bug 604.</li>
<li>Parse dates and IPv4 addresses in a locale- and libc-independent<br />
      manner, to avoid platform-dependent behavior on malformed input.</li>
<li>Build correctly when configured to build outside the main source<br />
      path. Patch from Michael Gold.</li>
<li>We were already rejecting relay begin cells with destination port<br />
      of 0. Now also reject extend cells with destination port or address<br />
      of 0. Suggested by lark.</li>
</ul>

<p><strong>Minor bugfixes (on 0.2.1.x):</strong></p>

<ul>
<li>Don't re-extend introduction circuits if we ran out of RELAY_EARLY<br />
      cells. Bugfix on 0.2.1.3-alpha. Fixes more of bug 878.</li>
<li>If we're an exit node, scrub the IP address to which we are exiting<br />
      in the logs. Bugfix on 0.2.1.8-alpha.</li>
</ul>

<p><strong>Minor features:</strong></p>

<ul>
<li>On Linux, use the prctl call to re-enable core dumps when the user<br />
      is option is set.</li>
<li>New controller event NEWCONSENSUS that lists the networkstatus<br />
      lines for every recommended relay. Now controllers like Torflow<br />
can keep up-to-date on which relays they should be using.</li>
<li>Update to the "February 26 2009" ip-to-country file.</li>
</ul>

<p>The original notice can be found at <a href="http://archives.seul.org/or/talk/Mar-2009/msg00047.html" rel="nofollow">http://archives.seul.org/or/talk/Mar-2009/msg00047.html</a></p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Comments are closed.</p>
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
